/*SQUADORDER.SQF
By General Barron
2/20/05
*REQUIRES SQUADNUMBER.SQF*

    group call squadOrder

  This returns an array of units in the group. The array only
includes living units, and the array is in order according to 
the unit's squad number (1-12), with the leader always being the
first element in the array. Note that the unit's index in the array
is NOT always the same as its squad #, since some units in the group
may have died, etc.

Most of this function's code is taken from bn880's sortBubble.sqf (2/24/2003)
(slightly modified to fit into this function)
*/


private ["_grp","_j","_count","_element","_numArray","_k","_tempNum","_tempVal"];

_grp = [];
{if((alive _x) && (_x != leader _x)) then {_grp = _grp + [_x];}} foreach units _this;

_count = count _grp;
_numArray = [];
_numArray resize _count;

// ACQUIRE NUMERIC VALUES FROM EVALUATION
_j = 0;
while {_j < _count} do 
{
	_element = _grp select _j;
	_numArray set [_j,_element call hs_squadNumber];
	_j = _j + 1;
};

_j = 0;
// SORT
while {_j < _count -1} do 
{
	_k = _j + 1;
	while {_k < _count} do
	{
		if (_numArray select _j > _numArray select _k) then
		{
			_tempNum = _numArray select _j;
			_numArray set [_j,(_numArray select _k)];
			_numArray set [_k,_tempNum];
			
			_tempVal = _grp select _j;
			_grp set [_j,(_grp select _k)];
			_grp set [_k,_tempVal];
		};
		_k = _k + 1;
	};
	_j = _j + 1;
};

if (isNull _this) then {_grp = [];} else {_grp = [leader _this] + _grp;};
_grp