/*
toEnd.sqf
By General Barron
aw_barron@hotmail.com

Sends specified elements of an array to the end of that array. Called like so:
[Array, [Elements]] call toEnd
Array - array to be sorted.
Elements - array of indexes to be sent to the end of array.

The order of Elements does not matter; the elements will be sent to the end in 
the order they appear in the array. Example:

_array = ["a","b","c","d","e"]
_elements = [0,3,2]
_result = [_array, _elements] call toEnd
Result is now: ["b","e","a","c","d"]
*/

private["_arr","_sorts","_i","_spc","_apnd"];

//array to sort
_arr = _this select 0;
//indices to send to end of array
_sorts = _this select 1;
//current index of array
_i = 0;
//indicates current blank space in array
_spc = 0;
//temp holding for items to go to end of
_apnd = [];

while {_i < count _arr} do
{
	if(_i IN _sorts) then {_apnd = _apnd + [_arr select _i];} else {if(_i != _spc) then {_arr set [_spc,_arr select _i];}; _spc = _spc + 1;};
	_i = _i + 1;
};
_i = 0;
while {_i < count _apnd} do
{
	_arr set [_spc + _i,_apnd select _i];
	_i = _i + 1
};

_arr