/*Part of the Multiple 'OnMapSingleClick' Command Handler
    v1.22     By General Barron

Run via 'onmapsingleclick' command. Executes all actions added to handler (if they are still active).
*/


//loop counter
_i = 0;
//flag to abort executing code for (double-clicks)
_exec = true;

while {_i < count GENB_mapclicks} do
{
	//extract next action in handler array
	_c = GENB_mapclicks select _i;

	//code to be executed
	_code = _c select 0;
	//number of executions ('clicks') left for this action
	_clicks = _c select 1;
	//condition that must be met to decrement click count
	_cond = _c select 2;
	//extra data to be passed to _code
	_data = _c select 3;
	//code to be executed on self-removal
	_removal = _c select 4;
	//last time map was clicked (for double-clicks)
	_last = _c select 5;

	//skip action if 0 clicks remain
	if (_clicks > 0) then
	{
		//check if this is a double-click action
		if (_last >= 0) then
		{
			//check if difference between current time and last time map was clicked
			//is too big to be considered a 'double click'
			if ( (time - _last) > 0.5 ) then {_c set [5, time]; _exec = false;};
		};

		//continue unless flag has been set (above)
		if (_exec) then
		{
			//decrement click counter only if condition is met
			if(_data call _cond) then {_clicks = _clicks - 1; _c set [1, _clicks];};
			_data call _code;
			//run self-removal code if last click has been reached
			if(_clicks == 0) then {3 call _removal;};
		};
	};
	_i = _i + 1;
	_exec = true;
};
