comment{
Based on Elevation.sqf v2.0 by Mr.Peanut
Modified by General Barron
v1.0   9 April 2006

Returns the height above sea level of a given set of 3D coordinates (i.e. those returned by 'getpos').

[x,y,<z>] call ASL_height
Returns the above-sea level height of the given coordinate.
Z = 0 by default.

Use z==0 to find the elevation of a given point on the ground.
Incorrect results might occur when passing a coordinate that is above an object (above a bridge for example).
};

{
	private "_pos"; _pos = _this;
	if ((count _pos) == 2) then {_pos = [_pos select 0, _pos select 1, 0]};

	if (format["%1", GENB_asl_logic] == "scalar bool array string 0xfcffffef") then {GENB_asl_logic = "logic" camCreate [0,0,0];};
	if (format["%1", GENB_asl_trigger] == "scalar bool array string 0xfcffffef") then {GENB_asl_trigger = "emptyDetector" camCreate [0,0,0];};

	GENB_asl_logic setPos _pos;
	GENB_asl_trigger setPos [_pos select 0, _pos select 1, 0];

	GENB_asl_trigger distance GENB_asl_logic
}
